/*->c.pp */


#include "stdafx.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h> 
#include <stdarg.h>


#include "os.h"
#include "bbc.h"
#include "sprite.h"
#include "wimp.h"
#include "wimpt.h"
#include "font.h"

#include "transform.h"

#include "xprocess.h"



#include "wos.h"
#include "poll.h"
#include "etc.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "sp.h"
#include "task.h"
#include "xhelp.h"
#include "trans.h"
#include "dbhi.h"
#include "key.h"
#include "temp.h"
#include "bits.h"
#include "scrap.h"
#include "filetype.h"


#include "xext.h"



#include "constants.h"
#include "str.h"


#include "file.h"
#include "view.h"
#include "viewo.h"


#include "units.h"

#include "object.h"
#include "select.h"
#include "chain.h"


#include "xxcolour.h"
#include "xcolour.h"





#include "line.h"

#include "pxstr.h"

#include "txstr.h"
#include "fmapstr.h"
#include "fox.h"


#include "border.h"




static HANDLE modulehandle;



static char * pppath;
static buffer bf;
static int    ppoutput;





static os_error * ppprintf(sobjectstr * sob,filestr * file,char * format, ...)
{
 os_error   * err;
 va_list      args;
 char         buffer[256];
 int          page;
 int          section;
 pagestr    * pagep;
 sectionstr * sectionp;
 int          chapter;



 ppoutput=1;

 va_start(args,format);
 vsprintf(buffer,format,args);
 va_end(args);


 pagesectionof((chainobject*)sob,file,&page,&section);

 sectionp=(sectionstr*)fob_find(section,file);
 chapter=sectionp->data.number;

 pagep=(pagestr*)fob_find(page,file);


 err=bf_printfeol(&bf,"Page %d.%d:%s",chapter,pagep->data.number,buffer);

 return(err);
}



/*
void openpictureinfobox(int fp)
{
 os_error      * err;
 pictboxstr    * pictp;
 int             info[128];
 int           * p;
 char            string[64];
 char          * q;
 int             xscale;
 int             yscale;


 err=pixselected(&cpictbox,menufile);
 if(cpictbox)
 {
  cview=menuview;
  cfile=menufile;

  pictp=(pictboxstr*)fob_find(cpictbox,cfile);

  cpicture=pictp->picture;
  yscale=pictp->pictdata.scale;
  xscale=ttmul(yscale,pictp->pictdata.aspect);

  err=dodboxspparent(&pictureinfobox,1,&pictureinfobox,&dbviewstack,cview->handle);
  if(!err)
  {
   err=impexpxinfo(cpicture,pictp->ftype,cfile,info);
   if(err)
   {
    dbclose(&pictureinfobox,DBCANCEL);
   }
   else
   {
    p=info;
    while(*p)
    {
     switch(*p)
     {
      case PT_LENGTH:
                     writeiconf(pictureinfobox.handle,3,"%s bytes",
                                                          memstring(p[2]));
                     break;

        case  PT_RES:
                     writeiconf(pictureinfobox.handle,9,
                              "%d x %d (%d x %d) dpi",
                              scale(p[2],0x10000,xscale),
                              scale(p[3],0x10000,yscale),
                              p[2],p[3]);
                     break;

        case  PT_PIX:
                     writeiconf(pictureinfobox.handle,7,"%d x %d",
                                p[2],p[3]);
                     break;

        case PT_INFO:
                     writeicon(pictureinfobox.handle,12,(char*)(p+2));
                     break;

        case  PT_DIM:
                     strcpy(string,
                       unitstostring(scale(scale(p[2],xscale,0x10000),25,16),
                                                           cview->data.units));
                     strcat(string," x ");
                     strcat(string,
                       unitstostring(scale(scale(p[3],yscale,0x10000),25,16),
                                                           cview->data.units));
                     writeiconf(pictureinfobox.handle,5,string);
                     break;


       case PT_CLASS:
                     if((p[2] & PT_CLASSFIELD)==PT_VEC)
                     {
                      strcpy(string,"Vector");
                      writeicon(pictureinfobox.handle,7,"-");
                      writeiconf(pictureinfobox.handle,9,"-");
                     }
                     else
                     {
                      sprintf(string,"%dbpp %s ",p[4]*p[5],
                              (p[3]==PT_CMYK)?"CMYK":"RGB");

                      q=string+strlen(string);

                      if(p[2] & PT_MASK)
                      {
                       strcpy(q,"- mask ");
                       q+=strlen(q);
                      }

                      if(p[2] & PT_INDEX)
                      {
                       sprintf(q,"- %d pal. entries ",(p[2] & PT_PALETTE)>>8);
                      }
                     }

                     writeiconf(pictureinfobox.handle,11,string);
                     break;
     }
     p=(int*)(((char*)p)+p[1]);
    }
   }
  }

  zreport(err);
 }

 USE(fp);
}

*/





static os_error * pfn(sobjectstr * sob,filestr * file,int * message)
{


 if(sob->type==OLINE)
 {
  if(((linestr*)sob)->data.thickness==0)
  {
   ppprintf(sob,file,"Zero thickness line");
  }
 }
 else
 if(sob->type==OTEXTBOX)
 {
  textboxstr    * textp;
  int             header;
  int             footer;
  texhdr        * texhp;
  int             footerfull;
  int             headerfull;
  int             full;


  textp=(textboxstr*)sob;


  full=textp->flags.full;
  headerfull=header=textp->data.header;
  footerfull=footer=textp->data.footer;

  if(header || footer)
  {
   texhp=(texhdr*)(((char*)textp)+sizeof(textboxstr)+3*sizeof(texsrc));
   header=texhp->header;
   headerfull=header && texhp->headerfull;
   footer=texhp->footer;
   footerfull=footer && texhp->footerfull;
  }

  if(full)       ppprintf(sob,file,"Overflowing text frame");
  if(headerfull) ppprintf(sob,file,"Overflowing text frame header");
  if(footerfull) ppprintf(sob,file,"Overflowing text frame footer");


  if(textp->frame)
  {
   borderlinestr * borderp;

   borderp=(borderlinestr*)fob_find(textp->frame,file);

   if(borderp->data.border[0].active && borderp->data.border[0].width==0)
                       ppprintf(sob,file,"Zero thickness text frame border");

   if(borderp->data.border[1].active && borderp->data.border[1].width==0)
                       ppprintf(sob,file,"Zero thickness text frame shadow");

  }
 }
 else
 if(sob->type==OPICTBOX)
 {
  pictboxstr    * pictp;


  pictp=(pictboxstr*)sob;


  if(pictp->frame)
  {
   borderlinestr * borderp;

   borderp=(borderlinestr*)fob_find(pictp->frame,file);

   if(borderp->data.border[0].active && borderp->data.border[0].width==0)
                       ppprintf(sob,file,"Zero thickness pict frame border");

   if(borderp->data.border[1].active && borderp->data.border[1].width==0)
                       ppprintf(sob,file,"Zero thickness pict frame shadow");
  }








 }


 return(NULL);

 USE(message);
}






static void prepress(void)
{
 os_error * err;
 viewstr  * view;
 filestr  * file;
 TCHAR      string[MAX_PATH];
 int        message;
	int        sh;

 view=getmenuview();
 file=view->file;

 message=OM_FUNCTION2;
 ppoutput=0;

 err=sc_create(&sh);
	if(!err)
	{
  err=xsprintf(NITEM(string),NULL,string,"%s.txt",sc_name(sh));
		if(!err)
		{
   err=bf_open(string,'w',DEFBUFFSIZE,&bf);
   if(!err)
   {
    bf_printfeoln(&bf,2,"PrePress check for %s",file->name);

    {
     colourbasestr * colourbase;
     int             colours;
     int             i;

     colours=file->hdr.colours;
     colourbase=(colourbasestr*)fob_find(colours,file);

     for(i=0;i<colourbase->n;i++)
     {
      if(colourbase->colour[i].n==KEYBLACK &&
        colourbase->colour[i].model.no!=CMYKMODEL)
          {bf_printfeol(&bf,"Black not defined in CMYK model");ppoutput=1;}

      if(colourbase->colour[i].n==KEYCYAN &&
        colourbase->colour[i].model.no!=CMYKMODEL)
          {bf_printfeol(&bf,"Cyan not defined in CMYK model");ppoutput=1;}

      if(colourbase->colour[i].n==KEYYELLOW &&
        colourbase->colour[i].model.no!=CMYKMODEL)
          {bf_printfeol(&bf,"Yellow not defined in CMYK model");ppoutput=1;}

      if(colourbase->colour[i].n==KEYMAGENTA &&
        colourbase->colour[i].model.no!=CMYKMODEL)
          {bf_printfeol(&bf,"Magenta not defined in CMYK model");ppoutput=1;}
     }

     if(ppoutput) bf_printfeol(&bf,"");
    }



    {
     fmapbasestr    * fbase;
     int              fmap;
     int              i;

     fmap=file->hdr.fmap;
     fbase=(fmapbasestr*)fob_find(fmap,file);

     for(i=0;i<fbase->n;i++)
     {
      if(fbase->fmaphdr[i].mapped)
      {
       {bf_printfeol(&bf,"Font %s missing",((char*)fbase->fmaphdr)+fbase->fmaphdr[i].offset);ppoutput=1;}
      }
     }

     if(ppoutput) bf_printfeol(&bf,"");
    }


    broadcastmessageb(file,DOC,&message,(void*)pfn);

  		if(!ppoutput)
  		{
     bf_printfeoln(&bf,1,"No problems found.",file->name);
		  	ppoutput=1;
  		}


    err=bf_closec(&bf,err,string,TEXTFILE);
			}

   if(!err && ppoutput)
   {
    oscommand(0,"open",string,NULL,NULL,0);
   }
		}
		err=sc_remove(sh,err);
 }

 zreport(err);
}





#define XFNS 2
         

static fndefn fntable[XFNS]=
{

 "prepress",(extfn)prepress,NULL,PVOID,0,

 NULL,NULL,NULL,0,0
};




static xfnlink fnlink;


static os_error * scriptevent(int eventn,int userhandle,
                                                    void * data,int data1)
{
 remevent(EVENT_SCRIPTINIT,scriptevent,0);
 return(addsymboltable(fntable,&fnlink));

 USE(eventn);
 USE(userhandle);
 USE(data);
 USE(data1);
}






extern "C" __declspec(dllexport) os_error * entrypoint(char * path)
{ 
 os_error * err;

 pppath=path;

 err=addevent(EVENT_SCRIPTINIT,scriptevent,0);

 return(err);
}







extern "C" BOOL __stdcall _DllMainCRTStartup( 
    HINSTANCE hinstDLL,     // handle to DLL module 
    DWORD fdwReason,        // reason for calling function 
    LPVOID lpvReserved)     // reserved 
{
 
 modulehandle=(HMODULE)hinstDLL;
 return(TRUE);
}
